using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;
using Microsoft.UI.Xaml.Data;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;
using Microsoft.UI.Xaml.Navigation;
using System.Collections.ObjectModel;
using Windows.Storage;
using System.IO.Compression;

// To learn more about WinUI, the WinUI project structure,
// and more about our project templates, see: http://aka.ms/winui-project-info.

namespace ArchivesCenter4
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class backup : Page
    {
        public backup()
        {
            this.InitializeComponent();
            LoadBackupFiles();
        }

        private void LoadBackupFiles()
        {
            // ȡûĵ·
            string documentsPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string backupsPath = Path.Combine(documentsPath, "ArchivesCenter4", "backups");
            if (!Directory.Exists(backupsPath))
                Directory.CreateDirectory(backupsPath);

            // ȡѹļ BackupFileInfo 
            var backupFiles = new List<BackupFileInfo>();
            if (Directory.Exists(backupsPath))
            {
                backupFiles = Directory.GetFiles(backupsPath, "*.zip")
                                       .Select(filePath => new BackupFileInfo
                                       {
                                           FileName = Path.GetFileNameWithoutExtension(filePath),
                                           FileSize = GetFileSize(filePath),
                                           FullPath = filePath
                                       })
                                       .ToList();
            }

            // 󶨵 ListView
            BackupFilesListView.ItemsSource = backupFiles;
        }

        private string GetFileSize(string filePath)
        {
            var fileInfo = new FileInfo(filePath);
            long sizeInBytes = fileInfo.Length;

            // ļСתΪʵĵλ
            if (sizeInBytes >= 1024 * 1024)
                return $"{sizeInBytes / (1024 * 1024):0.##} MB";
            else if (sizeInBytes >= 1024)
                return $"{sizeInBytes / 1024:0.##} KB";
            else
                return $"{sizeInBytes} bytes";
        }

        private void AppBarButton_Click(object sender, RoutedEventArgs e)
        {
            LoadBackupFiles();
        }

        private void BackupFilesListView_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            BDel.IsEnabled = BackupFilesListView.SelectedItem != null;
        }

        private void AppBarButton_Click_2(object sender, RoutedEventArgs e)
        {
            string documentsPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            string dataPath = Path.Combine(documentsPath, "ArchivesCenter4", "data");
            string backupsPath = Path.Combine(documentsPath, "ArchivesCenter4", "backups");

            //  data ļǷ
            if (!Directory.Exists(dataPath))
                return;

            string fileName = DateTime.Now.ToString("yyyy'-'MM'-'dd'T'HH'.'mm'.'ss'.'fffffff") + ".zip";
            string zipFilePath = Path.Combine(backupsPath, fileName);

            ZipFile.CreateFromDirectory(dataPath, zipFilePath);
            LoadBackupFiles();
        }

        private async void BDel_Click(object sender, RoutedEventArgs e)
        {
            ContentDialog deleteDialog = new ContentDialog
            {
                Title = "ȷɾ˻ԭ㣿",
                Content = "˲ɻָ",
                PrimaryButtonText = "ȷ",
                CloseButtonText = "ȡ",
                DefaultButton = ContentDialogButton.Primary,
                XamlRoot=this.XamlRoot
            };

            // ʾԻ򲢵ȴû
            ContentDialogResult result = await deleteDialog.ShowAsync();

            // ûİť߼
            if (result == ContentDialogResult.Primary)
            {
                var selectedItem = BackupFilesListView.SelectedItem as BackupFileInfo;
                if (selectedItem == null)
                    return;
                File.Delete(selectedItem.FullPath);
                LoadBackupFiles();
            }
        }

        private async void BAllDel_Click(object sender, RoutedEventArgs e)
        {
            ContentDialog deleteDialog = new ContentDialog
            {
                Title = "ȷɾȫԭ㣿",
                Content = "˲ɻָ",
                PrimaryButtonText = "ȷ",
                CloseButtonText = "ȡ",
                DefaultButton = ContentDialogButton.Primary,
                XamlRoot = this.XamlRoot
            };

            // ʾԻ򲢵ȴû
            ContentDialogResult result = await deleteDialog.ShowAsync();

            // ûİť߼
            if (result == ContentDialogResult.Primary)
            {
                string documentsPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
                string backupsPath = Path.Combine(documentsPath, "ArchivesCenter4", "backups");

                if (!Directory.Exists(backupsPath))
                    return;
                var zipFiles = Directory.GetFiles(backupsPath, "*.zip");
                if (zipFiles.Length == 0)
                    return;
                foreach (var file in zipFiles)
                {
                    File.Delete(file);
                }
                LoadBackupFiles();
            }
        }
    }
    public class BackupFileInfo
    {
        public string FileName { get; set; }
        public string FileSize { get; set; }
        public string FullPath { get; set; }
    }
}

